package cn.iocoder.yudao.module.tkdata.service.employeehosts;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.tkdata.controller.admin.employeehosts.vo.*;
import cn.iocoder.yudao.module.tkdata.dal.dataobject.employeehosts.EmployeeHostsDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工 Service 接口
 *
 * @author 芋道源码
 */
public interface EmployeeHostsService {

    /**
     * 创建员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createEmployeeHosts(@Valid EmployeeHostsSaveReqVO createReqVO);

    /**
     * 更新员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工
     *
     * @param updateReqVO 更新信息
     */
    void updateEmployeeHosts( EmployeeHostsSaveReqVO updateReqVO);

    /**
     * 删除员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工
     *
     * @param id 编号
     */
    void deleteEmployeeHosts(Long id);

    /**
    * 批量删除员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工
    *
    * @param ids 编号
    */
    void deleteEmployeeHostsListByIds(List<Long> ids);

    /**
     * 获得员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工
     *
     * @param id 编号
     * @return 员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工
     */
    EmployeeHostsDO getEmployeeHosts(Long id);

    /**
     * 获得员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工分页
     *
     * @param pageReqVO 分页查询
     * @return 员工分配主播表，结构和主播表相同，多了user_id 字段来区分所属员工分页
     */
    PageResult<EmployeeHostsDO> getEmployeeHostsPage(EmployeeHostsPageReqVO pageReqVO);

    Integer allocationHostsEmployee(List<EmployeeHostsSaveReqVO> hostsList);

    PageResult<EmployeeHostsDO> getEmployeeHostsPageWithSelf(@Valid EmployeeHostsPageReqVO pageReqVO);

    void batchUpdateEmployeeHosts(List<EmployeeHostsSaveReqVO> updateReqVOList);

    CompletedRateVO getEmployeeHostsCompleteWithSelf(@Valid Long userId);

    List<CompletedRateVO> getEmployeeHostsCompleteBarChart(@Valid List<Long> userId,Integer days);
}